A newer version of this documentation is available.

View Latest

Admin REST API (Static Page)

    Description of the Sync Gateway Admin REST API, alternative representation as a static page

    Resources

    This resources section groups together the available API operations under functional categories.

    Access Control

    Convenience API for Sync function upsert

    Get Sync Function

    GET /{db}/_config/sync
    Description

    Get the content of the current Sync Function

    Sync Gateway Roles Required (CBS 7.0.2 Developer Preview):

    • Sync Gateway Architect

    Parameters
    Type Name Description Schema

    Path

    db
    required

    Database name

    string

    Responses
    HTTP Code Description Schema

    200

    OK

    Sync_model

    401

    401 - Unauthorized - Error validating credentials

    No Content

    Consumes
    • application/javascript

    Example HTTP response
    Response 200
    "\"function(doc, oldDoc) {\\n  channel(doc.channels);\\n}\\n\\n\""

    Update Sync Function

    PUT /{db}/_config/sync
    Description

    Use this convenience endpoint to add or update the Sync function for an existing Sync Gateway database

    See the 'Model' below for more info

    Sync Gateway Roles Required (CBS 7.0.2 Developer Preview):

    • Sync Gateway Architect

    Parameters
    Type Name Description Schema

    Path

    db
    required

    Database name

    string

    Body

    sync function
    required

    The Javascipt code for the sync function

    Sync_model

    Responses
    HTTP Code Description Schema

    200

    OK

    Sync_model

    401

    401 - Unauthorized - Error validating credentials

    No Content

    Consumes
    • application/javascript

    Security
    Example HTTP request
    Request body
    "\"function(doc, oldDoc) {\\n  channel(doc.channels);\\n}\\n\\n\""
    Example HTTP response
    Response 200
    "\"function(doc, oldDoc) {\\n  channel(doc.channels);\\n}\\n\\n\""

    Delete Sync Function

    DELETE /{db}/_config/sync
    Description

    Use this convenience endpoint to remove an existing Sync function

    Sync Gateway Roles Required (CBS 7.0.2 Developer Preview):

    • Sync Gateway Architect

    Parameters
    Type Name Description Schema

    Path

    db
    required

    Database name

    string

    Body

    sync function
    required

    The Javascipt code for the sync function

    Sync_model

    Responses
    HTTP Code Description Schema

    200

    OK

    Sync_model

    401

    401 - Unauthorized - Error validating credentials

    No Content

    Consumes
    • application/javascript

    Example HTTP request
    Request body
    "\"function(doc, oldDoc) {\\n  channel(doc.channels);\\n}\\n\\n\""
    Example HTTP response
    Response 200
    "\"function(doc, oldDoc) {\\n  channel(doc.channels);\\n}\\n\\n\""

    Authentication

    Manage OpenID Connect providers

    OpenID Connect Authentication.

    GET /{db}/_oidc
    Description

    Called by clients to initiate the OIDC Authorization Code flow.

    Parameters
    Type Name Description Schema

    Path

    db
    required

    Database name

    string

    Query

    offline
    optional

    When true, requests a refresh token from the OP. Sets access_type=offline and prompt=consent on the redirect to the OP. Secure clients should set offline=true and persist the returned refresh token to secure storage.

    boolean

    Query

    provider
    optional

    OpenId Connect provider to be used for authentication, from the list of providers defined in the Sync Gateway Config. If not specified, will attempt to authenticate using the default provider.

    string

    Responses
    HTTP Code Description Schema

    302

    Redirect to the requested OpenID Connect provider for authentication. Redirect link is returned in the Location header.

    No Content

    400

    Bad request. Reason is returned as "OpenID Connect not configured for database default". If a provider was specified in the request, that provider was not defined in the Sync Gateway config. If no provider was specified, OpenID Connect is not configured in the Sync Gateway config.

    No Content

    500

    Server Error. Sync Gateway is unable to connect and validate the OpenID Connect provider requested.

    No Content

    OpenID Connect Authentication callback.

    GET /{db}/_oidc_callback
    Description

    Sync Gateway callback URL that clients are redirected to by the OpenID Connect provider.

    Parameters
    Type Name Description Schema

    Path

    db
    required

    Database name

    string

    Query

    code
    required

    OpenID Connect Authorization code.

    string

    Query

    provider
    optional

    OpenId Connect provider to be used for authentication, from the list of providers defined in the Sync Gateway Config. If not specified, will attempt to authenticate using the default provider.

    string

    Responses
    HTTP Code Description Schema

    200

    Successful OpenID Connect authentication.

    Response 200

    400

    Bad request.

    No Content

    401

    Authentication failed. Reason returned in the response body.

    No Content

    Response 200

    Name Description Schema

    access_token
    optional

    OpenID Connect access token

    string

    expires_in
    optional

    TTL for id_token

    number

    id_token
    optional

    OpenID Connect ID token

    string

    name
    optional

    Sync Gateway username

    string

    refresh_token
    optional

    OpenID Connect refresh token

    string

    session_id
    optional

    Sync Gateway session token

    string

    token_type
    optional

    OpenID Connect token type

    string

    OpenID Connect Authentication.

    GET /{db}/_oidc_challenge
    Description

    Called by clients to initiate the OIDC Authorization Code flow.

    Parameters
    Type Name Description Schema

    Path

    db
    required

    Database name

    string

    Query

    offline
    optional

    When true, requests a refresh token from the OP. Sets access_type=offline and prompt=consent on the redirect to the OP. Secure clients should set offline=true and persist the returned refresh token to secure storage.

    boolean

    Query

    provider
    optional

    OpenId Connect provider to be used for authentication, from the list of providers defined in the Sync Gateway Config. If not specified, will attempt to authenticate using the default provider.

    string

    Responses
    HTTP Code Description Schema

    302

    Redirect to the requested OpenID Connect provider for authentication. Redirect link is returned in the Location header.

    No Content

    400

    Bad request. Reason is returned as "OpenID Connect not configured for database default". If a provider was specified in the request, that provider was not defined in the Sync Gateway config. If no provider was specified, OpenID Connect is not configured in the Sync Gateway config.

    No Content

    500

    Server Error. Sync Gateway is unable to connect and validate the OpenID Connect provider requested.

    No Content

    OpenID Connect refresh.

    GET /{db}/_oidc_refresh
    Description

    Used to obtain a new OpenID Connect ID token based on the provided refresh token.

    Parameters
    Type Name Description Schema

    Path

    db
    required

    Database name

    string

    Query

    provider
    optional

    OpenId Connect provider to be used for authentication, from the list of providers defined in the Sync Gateway Config. If not specified, will attempt to authenticate using the default provider.

    string

    Query

    refresh_token
    required

    OpenID Connect refresh token.

    string

    Responses
    HTTP Code Description Schema

    200

    Successful OpenID Connect authentication.

    Response 200

    400

    Bad request.

    No Content

    401

    Authentication failed. Unable to refresh token.

    No Content

    Response 200

    Name Description Schema

    access_token
    optional

    OpenID Connect access token

    string

    expires_in
    optional

    TTL for id_token

    number

    id_token
    optional

    OpenID Connect ID token

    string

    name
    optional

    Sync Gateway username

    string

    session_id
    optional

    Sync Gateway session token

    string

    token_type
    optional

    OpenID Connect token type

    string

    Bootstrap Configuration

    Returns bootstrap settings and updates logging options

    Get Server Configuration

    GET /_config
    Description

    Returns the Sync Gateway configuration of the running instance. This is a good method to check if a particular key was set correctly on the config file.

    Sync Gateway Roles Required (CBS 7.0.2 Developer Preview):

    • Sync Gateway Dev Ops

    Responses
    HTTP Code Description Schema

    200

    Sync Gateway configuration of the running instance.

    Bootstrap_model

    Update Logging Options

    PUT /_config
    Description

    Update bootstrap logging options without needing a restart

    Sync Gateway Roles Required (CBS 7.0.2 Developer Preview):

    • Sync Gateway Dev Ops

    Parameters
    Type Name Schema

    Body

    bootstrap logging setting
    required

    Logging_model

    Responses
    HTTP Code Description Schema

    200

    Returned updated Bootstrap logging settings

    Logging_model

    Database Configuration

    Configure sync gateway databases

    Get Database Configuration

    GET /{db}/_config
    Description

    Returns the Sync Gateway configuration of the database specified in the URL. This is a good method to check if a particular key was set correctly on the config file.

    Sync Gateway Roles Required (CBS 7.0.2 Developer Preview):

    • Sync Gateway Architect

    Parameters
    Type Name Description Schema

    Path

    db
    required

    Database name

    string

    Responses
    HTTP Code Description Schema

    200

    Sync Gateway configuration of the running instance.

    No Content

    Update Database Configuration

    PUT /{db}/_config
    Description

    Use this endpoint to update the configuration of an existing Sync Gateway database.

    Provide the database name in the URL path. Provide the required database configuration settings as a JSON object in the request body.

    By default the updated database is brought online immediately, unless you include "offline": true in the configuration.

    Sync Gateway Roles Required (CBS 7.0.2 Developer Preview):

    • Sync Gateway Architect

    • Sync Gateway Application

    Parameters
    Type Name Description Schema

    Path

    db
    required

    Database name

    string

    Body

    database configuration details
    optional

    Provision the database configuration details as JSON object in request body

    Database_model

    Responses
    HTTP Code Description Schema

    200

    200 - OK - Operation successful

    No Content

    401

    401 - Unauthorized - Error validating credentials

    No Content

    Security

    Get Import_Filter Function

    GET /{db}/_config/import_filter
    Description

    Use this convenience endpoint to get the content of the current import_filter

    Sync Gateway Roles Required (CBS 7.0.2 Developer Preview):

    • Sync Gateway Architect

    Parameters
    Type Name Description Schema

    Path

    db
    required

    Database name

    string

    Responses
    HTTP Code Description Schema

    200

    OK

    Import_filter_model

    401

    401 - Unauthorized - Error validating credentials

    No Content

    Consumes
    • application/javascript

    Example HTTP response
    Response 200
    "\"function(doc) {\\n  if (doc.type != 'mobile') {\\n    return false\\n  }\\n  return true\\n}\\n\\n\""

    Update Import_Filter Function

    PUT /{db}/_config/import_filter
    Description

    Use this convenience endpoint to add or update the import_filter Javascript function for an existing Sync Gateway database.

    See the 'Model' below for more info

    Sync Gateway Roles Required (CBS 7.0.2 Developer Preview):

    • Sync Gateway Architect

    Parameters
    Type Name Description Schema

    Path

    db
    required

    Database name

    string

    Body

    import_filter
    required

    The Javascipt code for the import filter function

    Import_filter_model

    Responses
    HTTP Code Description Schema

    200

    OK

    Import_filter_model

    401

    401 - Unauthorized - Error validating credentials

    No Content

    Consumes
    • application/javascript

    Security
    Example HTTP request
    Request body
    "\"function(doc) {\\n  if (doc.type != 'mobile') {\\n    return false\\n  }\\n  return true\\n}\\n\\n\""
    Example HTTP response
    Response 200
    "\"function(doc) {\\n  if (doc.type != 'mobile') {\\n    return false\\n  }\\n  return true\\n}\\n\\n\""

    Delete Import_Filter Function

    DELETE /{db}/_config/import_filter
    Description

    Use this convenience endpoint to remove an existing`import_filter`.

    Sync Gateway Roles Required (CBS 7.0.2 Developer Preview):

    • Sync Gateway Architect

    Parameters
    Type Name Description Schema

    Path

    db
    required

    Database name

    string

    Responses
    HTTP Code Description Schema

    200

    OK

    Import_filter_model

    401

    401 - Unauthorized - Error validating credentials

    No Content

    Consumes
    • application/javascript

    Example HTTP response
    Response 200
    "\"function(doc) {\\n  if (doc.type != 'mobile') {\\n    return false\\n  }\\n  return true\\n}\\n\\n\""

    Get Sync Function

    GET /{db}/_config/sync
    Description

    Get the content of the current Sync Function

    Sync Gateway Roles Required (CBS 7.0.2 Developer Preview):

    • Sync Gateway Architect

    Parameters
    Type Name Description Schema

    Path

    db
    required

    Database name

    string

    Responses
    HTTP Code Description Schema

    200

    OK

    Sync_model

    401

    401 - Unauthorized - Error validating credentials

    No Content

    Consumes
    • application/javascript

    Example HTTP response
    Response 200
    "\"function(doc, oldDoc) {\\n  channel(doc.channels);\\n}\\n\\n\""

    Update Sync Function

    PUT /{db}/_config/sync
    Description

    Use this convenience endpoint to add or update the Sync function for an existing Sync Gateway database

    See the 'Model' below for more info

    Sync Gateway Roles Required (CBS 7.0.2 Developer Preview):

    • Sync Gateway Architect

    Parameters
    Type Name Description Schema

    Path

    db
    required

    Database name

    string

    Body

    sync function
    required

    The Javascipt code for the sync function

    Sync_model

    Responses
    HTTP Code Description Schema

    200

    OK

    Sync_model

    401

    401 - Unauthorized - Error validating credentials

    No Content

    Consumes
    • application/javascript

    Security
    Example HTTP request
    Request body
    "\"function(doc, oldDoc) {\\n  channel(doc.channels);\\n}\\n\\n\""
    Example HTTP response
    Response 200
    "\"function(doc, oldDoc) {\\n  channel(doc.channels);\\n}\\n\\n\""

    Delete Sync Function

    DELETE /{db}/_config/sync
    Description

    Use this convenience endpoint to remove an existing Sync function

    Sync Gateway Roles Required (CBS 7.0.2 Developer Preview):

    • Sync Gateway Architect

    Parameters
    Type Name Description Schema

    Path

    db
    required

    Database name

    string

    Body

    sync function
    required

    The Javascipt code for the sync function

    Sync_model

    Responses
    HTTP Code Description Schema

    200

    OK

    Sync_model

    401

    401 - Unauthorized - Error validating credentials

    No Content

    Consumes
    • application/javascript

    Example HTTP request
    Request body
    "\"function(doc, oldDoc) {\\n  channel(doc.channels);\\n}\\n\\n\""
    Example HTTP response
    Response 200
    "\"function(doc, oldDoc) {\\n  channel(doc.channels);\\n}\\n\\n\""

    Database Management

    Create and manage sync gateway databases

    Get Database Data

    GET /{db}/
    Description

    This request retrieves information about the database.

    Sync Gateway Roles Required (CBS 7.0.2 Developer Preview):

    • Sync Gateway Dev Ops

    Parameters
    Type Name Description Schema

    Path

    db
    required

    Database name

    string

    Responses
    HTTP Code Description Schema

    200

    Request completed successfully. The information is returned in the response body.

    Response 200

    401

    Unauthorized. Login required.

    No Content

    404

    Not Found. Requested database not found.

    No Content

    Response 200

    Name Description Schema

    db_name
    optional

    Name of the database

    string

    db_uuid
    optional

    Database identifier

    integer

    disk_format_version
    optional

    Database schema version

    integer

    disk_size
    optional

    Total amount of data stored on the disk (in bytes)

    integer

    instance_start_time
    optional

    Date and time the database was opened (in microseconds since 1 January 1970)

    string

    state
    optional

    The state of the specified database.

    Possible values are 'Online' and 'Offline'.

    A database can be taken offline and brought back online using the /{db}/_offline and /{db}/_online endpoints on the Admin REST API.

    string

    update_seq
    optional

    Number of updates to the database

    string

    Create Database

    PUT /{db}/
    Description

    Use this method to create a new Sync Gateway database.

    The database name is taken from the URL path. Pass the required database configuration settings as a JSON object in the request body.

    {
        "name": "todo_db"
        "bucket": "todo_app"
    }

    By default the created database is brought online immediately, unless you include "offline": true in the configuration.

    Sync Gateway Roles Required (CBS 7.0.2 Developer Preview):

    • Sync Gateway Architect

    Parameters
    Type Name Description Schema

    Path

    db
    required

    Database name

    string

    Body

    database configuration details
    optional

    Provision the database configuration details as JSON object in request body

    Database_model

    Responses
    HTTP Code Description Schema

    201

    201 - OK - Create Operation successful

    No Content

    401

    401 - Unauthorized - Error validating credentials

    No Content

    Security

    Delete Database

    DELETE /{db}/
    Description

    Delete database

    Sync Gateway Roles Required (CBS 7.0.2 Developer Preview):

    • Sync Gateway Architect

    Parameters
    Type Name Description Schema

    Path

    db
    required

    Database name

    string

    Responses
    HTTP Code Description Schema

    200

    Operation completed successfully

    doc-resp

    All docs

    POST /{db}/_all_docs
    Description

    This request retrieves specified documents from the database.

    Sync Gateway Roles Required (CBS 7.0.2 Developer Preview):

    • Sync Gateway Application

    • Sync Gateway Application Read Only

    Parameters
    Type Name Description Schema Default

    Path

    db
    required

    Database name

    string

    Query

    access
    optional

    Indicates whether to include in the response a list of what access this document grants (i.e. which users it allows to access which channels.) This option may only be used from the admin port.

    boolean

    "false"

    Query

    channels
    optional

    Indicates whether to include in the response a channels property containing an array of channels this document is assigned to. Channels not accessible by the user making the request will not be listed.

    boolean

    "false"

    Query

    include_docs
    optional

    Default is false. Indicates whether to include the associated document with each result. If there are conflicts, only the winning revision is returned.

    boolean

    "false"

    Query

    revs
    optional

    Default is false. Indicates whether to include a _revisions property for each document in the response, which contains a revision history of the document. The length of the returned revision tree can be specified with the revs_limit querystring parameter.

    boolean

    "false"

    Query

    update_seq
    optional

    Default is false. Indicates whether to include the update_seq (document sequence ID) property in the response.

    boolean

    "false"

    Body

    body
    optional

    Request body

    AllDocs

    Responses
    HTTP Code Description Schema

    200

    Query results

    QueryResult

    All docs

    GET /{db}/_all_docs
    Description

    This request returns a built-in view of all the documents in the database.

    Sync Gateway Roles Required (CBS 7.0.2 Developer Preview):

    • Sync Gateway Application

    • Sync Gateway Application Read Only

    Parameters
    Type Name Description Schema Default

    Path

    db
    required

    Database name

    string

    Query

    access
    optional

    Indicates whether to include in the response a list of what access this document grants (i.e. which users it allows to access which channels.) This option may only be used from the admin port.

    boolean

    "false"

    Query

    channels
    optional

    Indicates whether to include in the response a channels property containing an array of channels this document is assigned to. Channels not accessible by the user making the request will not be listed.

    boolean

    "false"

    Query

    endkey
    optional

    If this parameter is provided, stop returning records when the specified key is reached.

    string

    Query

    include_docs
    optional

    Default is false. Indicates whether to include the associated document with each result. If there are conflicts, only the winning revision is returned.

    boolean

    "false"

    Query

    keys
    optional

    Specify a list of document IDs. Note that this is an array field, so to retrieve docs with Ids of "keyid1" and "keyid4", for example, use a request in this format –

    curl -X GET \ '%22keyid1%22,%22keyid4%22' \ -H 'Accept: application/json'

    < string > array

    Query

    limit
    optional

    Limits the number of result rows to the specified value. Using a value of 0 has the same effect as the value 1.

    integer

    Query

    revs
    optional

    Default is false. Indicates whether to include a _revisions property for each document in the response, which contains a revision history of the document. The length of the returned revision tree can be specified with the revs_limit querystring parameter.

    boolean

    "false"

    Query

    startkey
    optional

    Returns records starting with the specified key.

    string

    Query

    update_seq
    optional

    Default is false. Indicates whether to include the update_seq (document sequence ID) property in the response.

    boolean

    "false"

    Responses
    HTTP Code Description Schema

    200

    Query results

    QueryResult

    Add, Update or Delete Bulk Documents

    POST /{db}/_bulk_docs
    Description

    This request enables you to add, update, or delete multiple documents to a database in a single request. To add new documents, you can either specify the ID (_id) or let the software create an ID. To update existing documents, you must provide the document ID, revision identifier (_rev), and new document values. To delete existing documents you must provide the document ID, revision identifier, and the deletion flag (_deleted).

    The JSON returned by the _bulk_docs operation consists of an array of JSON structures, one for each document in the original submission. The returned JSON structure should be examined to ensure that all of the documents submitted in the original request were successfully added to the database.

    Sync Gateway Roles Required (CBS 7.0.2 Developer Preview):

    • Sync Gateway Application

    Parameters
    Type Name Description Schema

    Path

    db
    required

    Database name

    string

    Body

    BulkDocsBody
    optional

    The request body

    BulkDocsBody

    BulkDocsBody

    Name Description Schema

    docs
    optional

    List containing new or updated documents. Each object in the array can contain the following properties _id, _rev, _deleted, and values for new and updated documents.

    < Document_model > array

    new_edits
    optional

    Indicates whether to assign new revision identifiers to new edits.
    Default : true

    boolean

    Responses
    HTTP Code Description Schema

    201

    Documents have been created or updated. The response object is an array with the status for each document submitted in the original request.

    BulkDocsSuccess

    409

    The operation failed with a forbidden error. Probably because the document already exists in the database but a revision number wasn’t specified.

    Forbidden

    Get Bulk Documents

    POST /{db}/_bulk_get
    Description

    This request returns any number of documents, as individual bodies in a MIME multipart response.

    Each enclosed body contains one requested document. The bodies appear in the same order as in the request, but can also be identified by their X-Doc-ID and X-Rev-ID headers. - A body for a document with no attachments will have content type application/json and contain the document itself. - A body for a document that has attachments will be written as a nested multipart/related body. Its first part will be the document’s JSON, and the subsequent parts will be the attachments (each identified by a Content-Disposition header giving its attachment name.)

    Sync Gateway Roles Required (CBS 7.0.2 Developer Preview):

    • Sync Gateway Application

    • Sync Gateway Application Read Only

    Parameters
    Type Name Description Schema Default

    Path

    db
    required

    Database name

    string

    Query

    attachments
    optional

    Include attachment bodies in response. Default is false.

    boolean

    "false"

    Query

    revs
    optional

    Default is false. Indicates whether to include a _revisions property for each document in the response, which contains a revision history of the document. The length of the returned revision tree can be specified with the revs_limit querystring parameter.

    boolean

    "false"

    Query

    revs_limit
    optional

    The number of revisions to include in the response from the document history.

    This property is only honoured if revs=true is also sent in the request.

    If revs=true is specified and revs_limit isn’t, the full revision history is returned.

    For more information see: Revisions page.

    integer

    Body

    BulkGetBody
    optional

    List of documents being requested.

    Each array element is an object that must contain an id property giving the document ID. It may contain a rev property if a specific revision is desired. It may contain an atts_since property (as in a single-document GET) to limit which attachments are sent.

    < BulkGetBody > array

    BulkGetBody

    Name Description Schema

    att_since
    optional

    att_since

    string

    id
    optional

    Document ID.

    string

    rev
    optional

    rev

    string

    Responses
    HTTP Code Description Schema

    200

    Request completed successfully

    No Content

    301

    Request failed with a forbidden error. This usually happens because the user requesting that document doesn’t have access to it. Access to documents is granted to users through channels.

    Response 301

    Response 301

    Name Description Schema

    _id
    optional

    The document ID that was requested

    string

    _removed
    optional

    Default : true

    boolean

    _rev
    optional

    The revision number that was requested

    string

    Produces
    • multipart/mixed

    Example HTTP response
    Response 200
    {
      "multipart/mixed (document found)" : "--1cba224ff2aa106566e3ab65de9c861c24558ba368f8cd7f6fcde53b88f4\nContent-Type: application/json\n\n{\"_id\":\"doc123\",\"_rev\":\"1-c543d6514c609f65180f94af247aaffe\",\"hello\":\"world!\"}\n--1cba224ff2aa106566e3ab65de9c861c24558ba368f8cd7f6fcde53b88f4\n",
      "multipart/mixed (document not found)" : "--1cba224ff2aa106566e3ab65de9c861c24558ba368f8cd7f6fcde53b88f4\nContent-Type: application/json; error=\"true\"\n\n{\"error\":\"not_found\",\"id\":\"doc1234\",\"reason\":\"missing\",\"status\":404}\n--1cba224ff2aa106566e3ab65de9c861c24558ba368f8cd7f6fcde53b88f4\n"
    }

    Changes

    POST /{db}/_changes
    Description

    Same as the GET /_changes request except the parameters are in the JSON body.

    Sync Gateway Roles Required (CBS 7.0.2 Developer Preview):

    • Sync Gateway Application

    • Sync Gateway Application Read Only

    Parameters
    Type Name Description Schema

    Path

    db
    required

    Database name

    string

    Body

    ChangesBody
    optional

    The request body

    ChangesBody

    ChangesBody

    Name Description Schema

    active_only
    optional

    Default is false. When true, the changes response doesn’t include either deleted documents, or notification for documents that the user no longer has access to.
    Default : false

    boolean

    channels
    optional

    A comma-separated list of channel names. The response will be filtered to only documents in these channels. (This parameter must be used with the sync_gateway/bychannel filter parameter; see below.)

    string

    doc_ids
    optional

    A list of document IDs as a valid JSON array. The response will be filtered to only documents with these IDs. (This parameter must be used with the _doc_ids filter parameter; see below.)

    < string > array

    feed
    optional

    Default is 'normal'. Specifies type of change feed. Valid values are normal, continuous, longpoll, websocket.
    Default : "normal"

    string

    filter
    optional

    Indicates that the returned documents should be filtered. The valid values are sync_gateway/bychannel and _doc_ids.

    string

    heartbeat
    optional

    Default is 0. Interval in milliseconds at which an empty line (CRLF) is written to the response. This helps prevent gateways from deciding the socket is idle and closing it. Only applicable to longpoll or continuous feeds. Overrides any timeout to keep the feed alive indefinitely. Setting to 0 results in no heartbeat.

    integer

    include_docs
    optional

    Default is false. Indicates whether to include the associated document with each result. If there are conflicts, only the winning revision is returned.
    Default : false

    boolean

    limit
    optional

    Limits the number of result rows to the specified value. Using a value of 0 has the same effect as the value 1.

    integer

    since
    optional

    Starts the results from the change immediately after the given sequence ID. Sequence IDs should be considered opaque; they come from the last_seq property of a prior response.

    object

    style
    optional

    Default is 'main_only'. Number of revisions to return in the changes array. The only possible value is all_docs and it returns all leaf revisions including conflicts and deleted former conflicts.
    Default : "main_only"

    string

    timeout
    optional

    Default is 300000. Maximum period in milliseconds to wait for a change before the response is sent, even if there are no results. Only applicable for longpoll or continuous feeds. Setting to 0 results in no timeout.

    integer

    Responses
    HTTP Code Description Schema

    200

    Request completed successfully

    Changes

    Get List of Changes (query parameters)

    GET /{db}/_changes
    Description

    This request retrieves a sorted list of changes made to documents in the database, in time order of application.

    Each document appears at most once, ordered by its most recent change, regardless of how many times it’s been changed. This request can be used to listen for update and modifications to the database for post processing or synchronization. A continuously connected changes feed is a reasonable approach for generating a real-time log for most applications.

    Sync Gateway Roles Required (CBS 7.0.2 Developer Preview):

    • Sync Gateway Application

    • Sync Gateway Application Read Only

    Parameters
    Type Name Description Schema Default

    Path

    db
    required

    Database name

    string

    Query

    active_only
    optional

    Default is false. When true, the changes response doesn’t include either deleted documents, or notification for documents that the user no longer has access to.

    boolean

    "false"

    Query

    channels
    optional

    A comma-separated list of channel names. The response will be filtered to only documents in these channels. (This parameter must be used with the sync_gateway/bychannel filter parameter; see below.)

    string

    Query

    doc_ids
    optional

    A list of document IDs as a valid JSON array. The response will be filtered to only documents with these IDs. This parameter must be used with the filter=_doc_ids and feed=normal parameters.

    < string > array

    Query

    feed
    optional

    Default is 'normal'. Specifies type of change feed. Valid values are normal, continuous, longpoll, websocket.

    string

    "normal"

    Query

    filter
    optional

    Indicates that the reported documents should be filtered. The valid values are sync_gateway/bychannel and _doc_ids.

    string

    Query

    heartbeat
    optional

    Default is 0. Interval in milliseconds at which an empty line (CRLF) is written to the response.

    This helps prevent gateways from deciding the socket is idle and closing it. Only applicable to longpoll or continuous feeds. Overrides any timeout to keep the feed alive indefinitely. Setting to 0 results in no heartbeat.

    integer

    0

    Query

    include_docs
    optional

    Default is false. Indicates whether to include the associated document with each result. If there are conflicts, only the winning revision is returned.

    boolean

    "false"

    Query

    limit
    optional

    Limits the number of result rows to the specified value. Using a value of 0 has the same effect as the value 1.

    integer

    Query

    since
    optional

    Starts the results from the change immediately after the given sequence ID.

    Sequence IDs should be considered opaque; they come from the last_seq property of a prior response.

    integer

    Query

    style
    optional

    Default is 'main_only'. Number of revisions to return in the changes array. main_only returns the current winning revision, all_docs returns all leaf revisions including conflicts and deleted former conflicts.

    string

    "main_only"

    Query

    timeout
    optional

    Default is 300000. Maximum period in milliseconds to wait for a change before the response is sent, even if there are no results. Only applicable for longpoll or continuous feeds. Setting to 0 results in no timeout.

    integer

    300000

    Responses
    HTTP Code Description Schema

    200

    Request completed successfully

    Changes

    Compact Database

    POST /{db}/_compact
    Description

    Use the /{db}/_compact endpoint to start a compaction process. The process purges the JSON bodies of non-leaf revisions.

    Using this endpoint following a failed compaction will trigger a restart of the compact_id at the appropriate phase (where possible).

    This process is also run periodically by the system.

    Note - Leaf revisions are not purged during compaction.

    Compaction does not remove JSON bodies of leaf nodes (conflicting branches). So it is also important to resolve conflicts in your application in order to re-claim disk space.

    Sync Gateway Roles Required (CBS 7.0.2 Developer Preview):

    • Sync Gateway Architect

    Parameters
    Type Name Description Schema Default

    Path

    db
    required

    Database name

    string

    Query

    action
    optional

    Use the action parameter to start or stop a _compact process.

    The value must be one of : - start - immediately starts (or restarts) a compaction and returns its status

    * stop - immediately stops the active compaction and returns the status

    This parameter works in conjunction with compaction type.

    string

    "start"

    Query

    dry_run
    optional

    Use dry_run only for attachment compaction.

    If this is set to true the process will run but will not execute the final purge of attachments. It can be used to check how many attachments will be purged.

    string

    "false"

    Query

    reset
    optional

    Use reset only for attachment compaction.

    If this is set to true the start action will not attempt to resume a failed process but will force a fresh compact to start.

    string

    "false"

    Query

    type
    optional

    Use the type option to specify the type of compaction required.

    The type must be one of : - attachment for legacy pre-3.0 attachment compaction

    * tombstone for database compaction, which purges the JSON bodies of non-leaf revisions.

    This parameter works in conjunction with compaction action.

    string

    "tombstone"

    Responses
    HTTP Code Description Schema

    200

    OK - This successful response indicates _compact process was started. The response body comprises a JSON object showing the _compact status.

    Compact_Response

    400

    Bad Request

    This can mean that a required parameter has not been provided, the value supplied is invalid, or the combination of provided parameters is invalid.

    Compaction API returns a 400 Bad Request error in the following cases: - A GET /{db}/_compact request is submitted with an invalid value for type parameter (anything other than tombstone or attachment). - A POST /{db}/_compact request is submitted with an invalid value for type parameter (type must be either tombstone or attachment) and or action parameter (action must be either start or stop).

    No Content

    503

    Service Unavailable

    A 503 Service Unavailable error indicates that the system is not ready to handle the submitted compaction start request due another compaction is running. You may encounter this error when you submit a compaction request in the middle of another.

    No Content

    Get Compact Status

    GET /{db}/_compact
    Description

    Use this request to return the current status of a compaction.

    Set the type parameter to one of: - tombstone - A GET request to /{db}/_compact?type=tombstone returns the number of tombstones removed. - attachment - A GET request to /{db}/_compact?type=attachment returns the number of attachments that are removed from the bucket.

    For example: { "status": "running", "start_time": "2021-12-02T18:26:17.086152Z", "last_error": "", "marked_attachments": 0, "purged_attachments": 0, "compact_id": "68302d2d-2c56-434e-94e0-33c0d0437828", "phase": "cleanup" }

    Parameters
    Type Name Description Schema Default

    Path

    db
    required

    Database name

    string

    Query

    type
    optional

    Use the type option to specify the type of compaction required.

    The type must be one of : - attachment for legacy pre-3.0 attachment compaction

    * tombstone for database compaction, which purges the JSON bodies of non-leaf revisions.

    This parameter works in conjunction with compaction action.

    string

    "tombstone"

    Responses
    HTTP Code Description Schema

    200

    OK - A successful response will return a JSON object containing the _compact status.

    The current phase of running compact processes is returned in phase.

    Compact_Response

    Take Database Offline

    POST /{db}/_offline
    Description

    This request takes the specified database offline.

    An offline database is not accessible through Sync Gateway’s Public REST API. However, some commands can be given to Sync Gateway through the Admin REST API.

    Taking a database offline will:

    • Cleanly closes all active _changes feeds for this database.

    • Rejects all access to the database through the Public REST API (503 Service Unavailable).

    • Rejects most Admin API requests (503 Service Unavailable). A specific, short list of Admin REST API requests remain available (GET /{db}, PUT /{db}/_config, POST /{db}/_resync).

    • Stops webhook event handlers.

    • Does not take the backing Couchbase Server bucket offline. The bucket remains available and Sync Gateway keeps its connection to the bucket.

    When a database is offline, you can load properties for the database, without stopping and re-starting the Sync Gateway instance. The new properties are applied when the database is brought online.

    Taking a database offline that is in the progress of coming online will take the database offline after it comes online.

    For more information about taking a database offline and bringing it back online, see this guide.

    Sync Gateway Roles Required (CBS 7.0.2 Developer Preview):

    • Sync Gateway Architect

    Parameters
    Type Name Description Schema

    Path

    db
    required

    Database name

    string

    Responses
    HTTP Code Description Schema

    200

    Database brought online

    No Content

    Bring Database Online.

    POST /{db}/_online
    Description

    When a database is online, Sync Gateway serves both Public and Admin REST API requests for the database. This request brings the specified database online, either immediately or after a specified delay.

    Bringing a database online:

    • Closes the databases connection to the backing Couchbase Server bucket.

    • Reloads the database configuration, and connects to the backing Couchbase Server bucket.

    • Re-establishes access to the database from the Public REST API.

    • Accepts all Admin API requests.

    You can bring an offline database online after a specific delay. Uses for this include:

    • Making a database available for Couchbase Mobile clients at a specific time.

    • Making databases on several Sync Gateway instances available at the same time.

    For more information about taking a database offline and bringing it back online, see this guide.

    Sync Gateway Roles Required (CBS 7.0.2 Developer Preview):

    • Sync Gateway Architect

    Parameters
    Type Name Description Schema

    Path

    db
    required

    Database name

    string

    Body

    body
    optional

    Optional request body to specify a delay.

    body

    body

    Name Description Schema

    delay
    optional

    Delay in seconds before bringing the database online.

    integer

    Responses
    HTTP Code Description Schema

    200

    OK - online request accepted.

    No Content

    503

    Service Unavailable - Database resync is in progress.

    No Content

    Start or Stop Resync

    POST /{db}/_resync
    Description

    Use the _resync operation whenever you have modified the database’s sync function such that the channel or access mappings for any existing document would change as a result.

    The request will start or stop the _resync process depending upon the action parameter provided. If no action parameter is given then start is assumed.

    action=start

    The start action causes all documents to be reprocessed by the database’s sync function. This is an asynchronous operation.

    When the sync function is invoked by _resync, the requireUser() and requireRole() calls will always return 'true'.

    A _resync operation on a database that is not in the offline state will be rejected (503 Service Unavailable).

    action=stop

    The currently running resync operation is stopped.

    regenerate_sequences=true Use this only when requested to do so by the Couchbase support team

    This request will start a resync while regenerating sequences.

    The resync action is carried out only on the node that the POST is made to. It is not cross-node aware.

    In a multi-node cluster, the resync must be only run on one node. Users should bring other nodes offline before initiating this action. Starting it on more than one node will result in multiple resyncs running, with undefined system behavior.

    Sync Gateway Roles Required (CBS 7.0.2 Developer Preview):

    • Sync Gateway Architect

    Parameters
    Type Name Description Schema Default

    Path

    db
    required

    Database name

    string

    Query

    action
    optional

    The action query can be “start” or “stop”. If neither is provided,“start” is used as the default.

    * Start will 'begin' the asynchrounous resync operation.

    * Stop will stop the resync operation and will return

    string

    "start"

    Query

    regenerate_sequences
    optional

    Use this only when requested to do so by the Couchbase support team

    Set regenerate_sequences=true along with action=start in order to begin a resync while regenerating sequences.

    string

    "none"

    Responses
    HTTP Code Description Schema

    200

    OK

    Resync-response

    400

    400 - Database _resync not running

    No Content

    503

    503 error code. The meaning varies depending on the action parameter:

    * action=start - Database must be offline before calling _resync.

    * action=stop - Database _resync already in progress

    No Content

    Show resync status

    GET /{db}/_resync
    Description

    This request returns the status of the asynchronous _resync operation, including:

    • status

    • docs processed

    • docs changed

    • last error (if any)

    Sync Gateway Roles Required:

    • Sync Gateway Architect

    Parameters
    Type Name Description Schema

    Path

    db
    required

    Database name

    string

    Responses
    HTTP Code Description Schema

    200

    OK

    Resync-response

    Get Revisions DIff List

    POST /{db}/_revs_diff
    Description

    Given a set of document/revision IDs, returns the subset of those that do not correspond to revisions stored in the database.

    Sync Gateway Roles Required (CBS 7.0.2 Developer Preview):

    • Sync Gateway Application

    Parameters
    Type Name Description Schema

    Path

    db
    required

    Database name

    string

    Body

    body
    optional

    Request body

    < body > array

    body

    Name Description Schema

    key
    optional

    document id

    string

    value
    optional

    revision id

    string

    Responses
    HTTP Code Description Schema

    200

    The request was successful. Returns a list of revision IDs for that document (the ones that are not stored in the database)

    < Response 200 > array

    Response 200

    Name Description Schema

    key
    optional

    document id

    string

    value
    optional

    revision id

    string

    Database Security

    Create and manage database users and roles

    Create New Role

    POST /{db}/_role
    Description

    This request creates a new role

    Sync Gateway Roles Required (CBS 7.0.2 Developer Preview):

    • Sync Gateway Architect

    • Sync Gateway Application

    Parameters
    Type Name Description Schema

    Path

    db
    required

    Database name

    string

    Body

    role
    optional

    The message body is a JSON document that contains the following objects.

    Role_model

    Responses
    HTTP Code Description Schema

    201

    201 - OK - Create Operation successful

    No Content

    401

    401 - Unauthorized - Error validating credentials

    No Content

    409

    409 - Conflict - For example, an object with this name already exists

    No Content

    Get All Roles

    GET /{db}/_role
    Description

    This request returns all the roles in the specified database.

    Sync Gateway Roles Required (CBS 7.0.2 Developer Preview):

    • Sync Gateway Architect

    • Sync Gateway Application

    • Sync Gateway Application Read Only

    Parameters
    Type Name Description Schema

    Path

    db
    required

    Database name

    string

    Responses
    HTTP Code Description Schema

    200

    200 OK - Returns the list of roles as an array of strings

    The message body contains the list of roles in a JSON array. Each element of the array is a string representing the name of a role in the specified database.

    < string > array

    401

    401 - Unauthorized - Error validating credentials

    No Content

    Get Specific Role

    GET /{db}/_role/{name}
    Description

    Request a specific role by name.

    Sync Gateway Roles Required (CBS 7.0.2 Developer Preview):

    • Sync Gateway Architect

    • Sync Gateway Application

    • Sync Gateway Application Read Only

    Without Application or Application Read Only users will be unable to see dynamic user or role data.

    Parameters
    Type Name Description Schema

    Path

    db
    required

    Database name

    string

    Path

    name
    required

    Role name, may contain any combination of the characters [a-z A-Z 0-9 - + . @ %], when creating a role any other characters must be percent encoded, see: https://en.wikipedia.org/wiki/Percent-encoding.

    When passing a role name in a URL path it must be escaped again using percent encoding for example if a role is created with the name "0|59", the '|' character must first be percent-encoded resulting in "0%7C59". When using the same role name in a URL path it must be percent-encoded a second time resulting in "0%257C59"

    string

    Responses
    HTTP Code Description Schema

    200

    The response contains information about this role.

    Response 200

    401

    401 - Unauthorized - Error validating credentials

    No Content

    Response 200

    Name Description Schema

    admin_channels
    optional

    The admin channels that this role has granted access to. Admin channels are the ones which are granted access to in the config file or via the Admin REST API.

    < string > array

    all_channels
    optional

    All the channels that this role has access to.

    < string > array

    name
    optional

    string

    Update Specific Role

    PUT /{db}/_role/{name}
    Description

    Use this convenience endpoint to upsert a Sync Gateway role.

    Sync Gateway Roles Required (CBS 7.0.2 Developer Preview):

    • Sync Gateway Architect

    • Sync Gateway Application

    Parameters
    Type Name Description Schema

    Path

    db
    required

    Database name

    string

    Path

    name
    required

    Role name, may contain any combination of the characters [a-z A-Z 0-9 - + . @ %], when creating a role any other characters must be percent encoded, see: https://en.wikipedia.org/wiki/Percent-encoding.

    When passing a role name in a URL path it must be escaped again using percent encoding for example if a role is created with the name "0|59", the '|' character must first be percent-encoded resulting in "0%7C59". When using the same role name in a URL path it must be percent-encoded a second time resulting in "0%257C59"

    string

    Body

    role
    optional

    The message body is a JSON document that contains the following objects.

    Role_model

    Responses
    HTTP Code Description Schema

    200

    200 - OK - Operation successful

    No Content

    201

    201 - OK - Create Operation successful

    No Content

    401

    401 - Unauthorized - Error validating credentials

    No Content

    Security

    Delete Specific Role

    DELETE /{db}/_role/{name}
    Description

    This request deletes the role with the specified name.

    Sync Gateway Roles Required (CBS 7.0.2 Developer Preview):

    • Sync Gateway Architect

    • Sync Gateway Application

    Parameters
    Type Name Description Schema

    Path

    db
    required

    Database name

    string

    Path

    name
    required

    Role name, may contain any combination of the characters [a-z A-Z 0-9 - + . @ %], when creating a role any other characters must be percent encoded, see: https://en.wikipedia.org/wiki/Percent-encoding.

    When passing a role name in a URL path it must be escaped again using percent encoding for example if a role is created with the name "0|59", the '|' character must first be percent-encoded resulting in "0%7C59". When using the same role name in a URL path it must be percent-encoded a second time resulting in "0%257C59"

    string

    Responses
    HTTP Code Description Schema

    200

    200 OK - The role was successfully deleted

    No Content

    Create New User

    POST /{db}/_user/
    Description

    This request creates a new user

    Sync Gateway Roles Required (CBS 7.0.2 Developer Preview):

    • Sync Gateway Architect

    • Sync Gateway Application`

    Parameters
    Type Name Description Schema

    Path

    db
    required

    Database name

    string

    Body

    user configuration data
    optional

    Provision the user configuration data in JSON format in the body

    User_model

    Responses
    HTTP Code Description Schema

    201

    201 - OK - Create Operation successful

    No Content

    401

    401 - Unauthorized - Error validating credentials

    No Content

    409

    409 - Conflict - For example, an object with this name already exists

    No Content

    Get All Users

    GET /{db}/_user/
    Description

    This request returns a list of all users

    Sync Gateway Roles Required (CBS 7.0.2 Developer Preview):

    • Sync Gateway Architect

    • Sync Gateway Application

    • Sync Gateway Application Read Only

    Parameters
    Type Name Description Schema

    Path

    db
    required

    Database name

    string

    Responses
    HTTP Code Description Schema

    200

    The message body contains the list of users in a JSON array. Each element of the array is a string representing the name of a user in the specified database.

    < string > array

    404

    404 - Not Found - Object missing or misreferenced

    No Content

    Get User Data

    GET /{db}/_user/{name}
    Description

    This request returns information about the specified user.

    Sync Gateway Roles Required (CBS 7.0.2 Developer Preview):

    • Sync Gateway Architect

    • Sync Gateway Application

    • Sync Gateway Application Read Only

    Without Application or Application Read Only users will be unable to see dynamic user or role data.

    Parameters
    Type Name Description Schema

    Path

    db
    required

    Database name

    string

    Path

    name
    required

    User’s name, may contain contain any combination of the characters [a-z A-Z 0-9 - + . @ %], when creating a user any other characters must be percent encoded, see: https://en.wikipedia.org/wiki/Percent-encoding.

    When passing a user name in a URL path it must be escaped again using percent encoding for example if a user is created with the name "0|59", the '|' character must first be percent-encoded resulting in "0%7C59". When using the same user name in a URL path it must be percent-encoded a second time resulting in "0%257C59"

    string

    Responses
    HTTP Code Description Schema

    200

    200 OK - Returns information about the specified user

    User-response

    401

    401 - Unauthorized - Error validating credentials

    No Content

    Update User Data

    PUT /{db}/_user/{name}
    Description

    Use this method to create or update a user

    Sync Gateway Roles Required (CBS 7.0.2 Developer Preview):

    • Sync Gateway Architect

    • Sync Gateway Application

    Parameters
    Type Name Description Schema

    Path

    db
    required

    Database name

    string

    Path

    name
    required

    User’s name, may contain contain any combination of the characters [a-z A-Z 0-9 - + . @ %], when creating a user any other characters must be percent encoded, see: https://en.wikipedia.org/wiki/Percent-encoding.

    When passing a user name in a URL path it must be escaped again using percent encoding for example if a user is created with the name "0|59", the '|' character must first be percent-encoded resulting in "0%7C59". When using the same user name in a URL path it must be percent-encoded a second time resulting in "0%257C59"

    string

    Body

    user configuration data
    optional

    Provision the user configuration data in JSON format in the body

    User_model

    Responses
    HTTP Code Description Schema

    200

    200 - OK - Operation successful

    No Content

    201

    201 - OK - Create Operation successful

    No Content

    401

    401 - Unauthorized - Error validating credentials

    No Content

    Security

    Delete Specific User

    DELETE /{db}/_user/{name}
    Description

    This request deletes the user with the specified name

    Sync Gateway Roles Required (CBS 7.0.2 Developer Preview):

    • Sync Gateway Architect

    • Sync Gateway Application

    Parameters
    Type Name Description Schema

    Path

    db
    required

    Database name

    string

    Path

    name
    required

    User’s name, may contain contain any combination of the characters [a-z A-Z 0-9 - + . @ %], when creating a user any other characters must be percent encoded, see: https://en.wikipedia.org/wiki/Percent-encoding.

    When passing a user name in a URL path it must be escaped again using percent encoding for example if a user is created with the name "0|59", the '|' character must first be percent-encoded resulting in "0%7C59". When using the same user name in a URL path it must be percent-encoded a second time resulting in "0%257C59"

    string

    Responses
    HTTP Code Description Schema

    200

    200 - OK - Operation successful

    No Content

    401

    401 - Unauthorized - Error validating credentials

    No Content

    Design Documents

    Work with sync gateway design docs

    Get Views of a design document

    GET /{db}/_design/{ddoc}
    Description

    Query a design document.

    Sync Gateway Roles Required (CBS 7.0.2 Developer Preview):

    • Sync Gateway Application

    • Sync Gateway Application Read Only

    Parameters
    Type Name Description Schema

    Path

    db
    required

    Database name

    string

    Path

    ddoc
    required

    Design document name

    string

    Responses
    HTTP Code Description Schema

    200

    Views for design document

    Response 200

    Response 200

    Name Schema

    my_view_name
    optional

    View

    Update views of a design document

    PUT /{db}/_design/{ddoc}
    Description

    Update views of a design document

    Sync Gateway Roles Required (CBS 7.0.2 Developer Preview):

    • Sync Gateway Application

    Parameters
    Type Name Description Schema

    Path

    db
    required

    Database name

    string

    Path

    ddoc
    required

    Design document name

    string

    Body

    body
    optional

    The request body

    View

    Responses
    HTTP Code Description Schema

    200

    OK

    No Content

    Delete design document

    DELETE /{db}/_design/{ddoc}
    Description

    Delete a design document.

    Sync Gateway Roles Required (CBS 7.0.2 Developer Preview):

    • Sync Gateway Application

    Parameters
    Type Name Description Schema

    Path

    db
    required

    Database name

    string

    Path

    ddoc
    required

    Design document name

    string

    Responses
    HTTP Code Description Schema

    200

    The status

    Design

    default

    Unexpected error

    Error

    Query a view

    GET /{db}/_design/{ddoc}/_view/{view}
    Description

    Query a view on a design document.

    Sync Gateway Roles Required (CBS 7.0.2 Developer Preview):

    • Sync Gateway Application

    • Sync Gateway Application Read Only

    Parameters
    Type Name Description Schema

    Path

    db
    required

    Database name

    string

    Path

    ddoc
    required

    Design document name

    string

    Path

    view
    required

    View name

    string

    Query

    conflicts
    optional

    Include conflict information in the response. This parameter is ignored if the include_docs parameter is false.

    boolean

    Query

    descending
    optional

    Return documents in descending order.

    boolean

    Query

    end_key
    optional

    Alias for the endkey parameter.

    string

    Query

    end_key_doc_id
    optional

    Alias for the endkey_docid parameter.

    string

    Query

    endkey
    optional

    If this parameter is provided, stop returning records when the specified key is reached.

    string

    Query

    endkey_docid
    optional

    If this parameter is provided, stop returning records when the specified document identifier is reached.

    string

    Query

    group
    optional

    Group the results using the reduce function to a group or single row.

    boolean

    Query

    group_level
    optional

    Specify the group level to be used.

    integer

    Query

    include_docs
    optional

    Only works when using Couchbase Server 3.0 and earlier. Indicates whether to include the full content of the documents in the response.

    boolean

    Query

    inclusive_end
    optional

    Indicates whether the specified end key should be included in the result.

    boolean

    Query

    key
    optional

    If this parameter is provided, return only document that match the specified key.

    string

    Query

    limit
    optional

    If this parameter is provided, return only the specified number of documents.

    integer

    Query

    skip
    optional

    If this parameter is provided, skip the specified number of documents before starting to return results.

    integer

    Query

    stale
    optional

    Allow the results from a stale view to be used, without triggering a rebuild of all views within the encompassing design document. Valid values are ok and update_after.

    string

    Query

    start_key
    optional

    Alias for startkey param.

    string

    Query

    startkey
    optional

    If this parameter is provided, return documents starting with the specified key.

    string

    Query

    startkey_docid
    optional

    If this parameter is provided, return documents starting with the specified document identifier.

    string

    Query

    update_seq
    optional

    Indicates whether to include the update_seq property in the response.

    boolean

    Responses
    HTTP Code Description Schema

    200

    Query results

    QueryResult

    Document

    Manage documents and attachments

    Create Document

    POST /{db}/
    Description

    This request creates a new document in the specified database.

    You can either specify the document ID by including the _id in the request message body (the value must be a string), or let the software generate an ID.

    The maximum size allowed for a document is 20MB.

    Sync Gateway Roles Required (CBS 7.0.2 Developer Preview):

    • Sync Gateway Application

    Parameters
    Type Name Description Schema

    Path

    db
    required

    Database name

    string

    Body

    body
    optional

    The document body

    object

    Responses
    HTTP Code Description Schema

    201

    Operation completed successfully

    doc-resp

    Get Specific Local Document

    GET /{db}/_local/{local_doc}
    Description

    This request retrieves a local document.

    Local document IDs begin with _local/. Local documents are not replicated or indexed, don’t support attachments, and don’t save revision histories. In practice they are almost only used by Couchbase Lite’s replicator, as a place to store replication checkpoint data.

    Sync Gateway Roles Required (CBS 7.0.2 Developer Preview):

    • Sync Gateway Application

    • Sync Gateway Application Read Only

    Parameters
    Type Name Description Schema

    Path

    db
    required

    Database name

    string

    Path

    local_doc
    required

    Local document IDs begin with _local/.

    string

    Responses
    HTTP Code Description Schema

    200

    OK

    No Content

    Update Specific Local Document

    PUT /{db}/_local/{local_doc}
    Description

    This request creates or updates a local document. Local document IDs begin with _local/. Local documents are not replicated or indexed, don’t support attachments, and don’t save revision histories. In practice they are almost only used by the client’s replicator, as a place to store replication checkpoint data.

    Sync Gateway Roles Required (CBS 7.0.2 Developer Preview):

    • Sync Gateway Application

    Parameters
    Type Name Description Schema

    Path

    db
    required

    Database name

    string

    Path

    local_doc
    required

    Local document IDs begin with _local/.

    string

    Responses
    HTTP Code Description Schema

    201

    Operation completed successfully

    doc-resp

    Delete Specific Local Document

    DELETE /{db}/_local/{local_doc}
    Description

    This request deletes a local document. Local document IDs begin with _local/. Local documents are not replicated or indexed, don’t support attachments, and don’t save revision histories. In practice they are almost only used by Couchbase Lite’s replicator, as a place to store replication checkpoint data.

    Sync Gateway Roles Required (CBS 7.0.2 Developer Preview):

    • Sync Gateway Application

    Parameters
    Type Name Description Schema

    Path

    db
    required

    Database name

    string

    Path

    local_doc
    required

    Local document IDs begin with _local/.

    string

    Query

    batch
    optional

    Stores the document in batch mode. To use, set the value to ok.

    string

    Query

    rev
    optional

    Revision identifier of the parent revision the new one should replace. (Not used when creating a new document.)

    string

    Responses
    HTTP Code Description Schema

    200

    Operation completed successfully

    doc-resp

    Purge document

    POST /{db}/_purge
    Description

    The purge command provides a way to remove a document from the bucket itself. The operation removes all the revisions (active and tombstones) for the specified document(s). A common usage of this endpoint is to remove tombstone documents that are no longer needed, thus recovering storage space and reducing data replicated to clients. Other clients are not notified when a revision has been purged; so in order to purge a revision from the system it must be done from all databases (on Couchbase Lite and Sync Gateway).

    When convergence is enabled (introduced in Sync Gateway 1.5), this endpoint removes the document and its associated extended attributes.

    Sync Gateway Roles Required (CBS 7.0.2 Developer Preview):

    • Sync Gateway Application

    Parameters
    Type Name Description Schema

    Path

    db
    required

    Database name

    string

    Body

    body
    optional

    The message body is a JSON document that contains the following objects.

    PurgeBody

    Responses
    HTTP Code Description Schema

    200

    OK - The purge operation was successful

    < string > array

    Document with metadata

    GET /{db}/_raw/{doc}
    Description

    Returns the document with the metadata.

    Note: The direct use of this endpoint is unsupported. The sync metadata is maintained internally by Sync Gateway and its structure can change. It should not be used to drive business logic of applications since the response to the /{db}/_raw/{id} endpoint can change at any time.\

    Sync Gateway Roles Required (CBS 7.0.2 Developer Preview):

    • Sync Gateway Application

    • Sync Gateway Application Read Only

    Parameters
    Type Name Description Schema

    Path

    db
    required

    Database name

    string

    Path

    doc
    required

    Document ID

    string

    Responses
    HTTP Code Description Schema

    200

    OK

    DocMetadata

    Revision Tree structure in Graphviz Dot format | not officially supported

    GET /{db}/_revtree/{doc}
    Description

    Returns the dot syntax of the revision tree which can be rendered into a PNG image with the CLI dot tool.

    • Install the dot tool via brew install graphviz.

    • Save the response text to a file (for example, revtree.dot).

    • Render a PNG by calling dot -Tpng revtree.dot > revtree.png.

    Note: This endpoint is useful for debugging purposes only. It is not officially supported.

    Sync Gateway Roles Required (CBS 7.0.2 Developer Preview):

    • Sync Gateway Application

    • Sync Gateway Application Read Only

    Parameters
    Type Name Description Schema

    Path

    db
    required

    Database name

    string

    Path

    doc
    required

    Document ID

    string

    Responses
    HTTP Code Description Schema

    200

    Success and returns the revtree as plain text.

    No Content

    Produces
    • text/plain

    Get Specific Document

    GET /{db}/{doc}
    Description

    This request retrieves a document from a database. Sync Gateway Roles Required (CBS 7.0.2 Developer Preview): - Sync Gateway Application - Sync Gateway Application Read Only

    Parameters
    Type Name Description Schema Default

    Path

    db
    required

    Database name

    string

    Path

    doc
    required

    Document ID

    string

    Query

    attachments
    optional

    Include attachment bodies in response. Default is false.

    boolean

    "false"

    Query

    atts_since
    optional

    Include attachments only since specified revisions. Does not include attachments for specified revisions.

    < string > array

    Query

    open_revs
    optional

    Option to fetch specified revisions of the document. The value can be all to fetch all leaf revisions or an array of revision numbers (i.e. open_revs=["rev1", "rev2"]). Only leaf revision bodies that haven’t been pruned are guaranteed to be returned.

    If this option is specified the response will be in multipart format. Use the Accept: application/json request header to get the result as a JSON object.

    string

    Query

    rev
    optional

    Revision identifier of the revision to get.

    By default, Sync Gateway returns the current revision. This parameter is generally only needed for conflict resolution. For example where the app might need to retrieve a conflicting leaf revision that isn’t the current revision.

    string

    Query

    revs
    optional

    Default is false. Indicates whether to include a _revisions property for each document in the response, which contains a revision history of the document. The length of the returned revision tree can be specified with the revs_limit querystring parameter.

    boolean

    "false"

    Query

    show_exp
    optional

    Whether to show the _exp property in the response.

    boolean

    "false"

    Responses
    HTTP Code Description Schema

    200

    The message body contains the following objects in a JSON document.

    object

    Create or update document

    PUT /{db}/{doc}
    Description

    This request creates a new document or creates a new revision of an existing document. It enables you to specify the identifier for a new document rather than letting the software create an identifier. If you want to create a new document and let the software create an identifier, use the POST /db request. If the document specified by doc does not exist, a new document is created and assigned the identifier specified in doc. If the document already exists, the document is updated with the JSON document in the message body and given a new revision. The maximum size allowed for a document is 20MB.

    Since Sync Gateway 1.3, an expiry property (_exp) can also be specified to purge the document after a given time. If convergence is enabled (introduced in Sync Gateway 1.5), the behavior of the expiry feature changes in the following way: when the expiry value is reached, instead of getting purged, the active revision of the document is tombstoned. If there is another non-tombstoned revision for this document (i.e a conflict) it will become the active revision. The tombstoned revision will be purged when the server’s metadata purge interval is reached.

    Sync Gateway Roles Required (CBS 7.0.2 Developer Preview):

    • Sync Gateway Application

    Parameters
    Type Name Description Schema Default

    Path

    db
    required

    Database name

    string

    Path

    doc
    required

    Document ID

    string

    Query

    new_edits
    optional

    Default is true. Setting this to false indicates that the request body is an already-existing revision that should be directly inserted into the database, instead of a modification to apply to the current document. (This mode is used by the replicato.)

    This option must be used in conjunction with the _revisions property in the request body.

    boolean

    "true"

    Query

    rev
    required

    Revision identifier of the revision to update. It must be the last revision in the history.

    string

    Body

    Document
    optional

    Request body

    Document_model

    Responses
    HTTP Code Description Schema

    200

    Operation completed successfully

    doc-resp

    Delete document

    DELETE /{db}/{doc}
    Description

    This request deletes a document from the database. When a document is deleted, the revision number is updated so the database can track the deletion in synchronized copies.

    Sync Gateway Roles Required (CBS 7.0.2 Developer Preview):

    • Sync Gateway Application

    Parameters
    Type Name Description Schema

    Path

    db
    required

    Database name

    string

    Path

    doc
    required

    Document ID

    string

    Query

    rev
    required

    Revision identifier of the revision to delete. It must be the identifier of the latest revision in the history.

    string

    Responses
    HTTP Code Description Schema

    200

    OK

    No Content

    Get attachment

    GET /{db}/{doc}/{attachment}
    Description

    Use this request to get the file attachment associated with a document. It returns the raw data of the associated attachment, just as if you were accessing a static file.

    The Content-Type response header is the same content type set when the document attachment was added to the database.

    To remove an attachment from a document, simply update the _attachments dictionary of the document in the PUT "/{db}/{id}" request.

    Use the meta parameter to request that only the document ID of the attachment blob be returned

    Sync Gateway Roles Required (CBS 7.0.2 Developer Preview):

    • Sync Gateway Application

    • Sync Gateway Application Read Only

    Parameters
    Type Name Description Schema Default

    Path

    attachment
    required

    Attachment name. This value must be URL encoded. For example, if the attachment name is blob_/avatar, the path component passed to the URL should be blob_%2Favatar (tested with URLEncoder).

    string

    Path

    db
    required

    Database name

    string

    Path

    doc
    required

    Document ID

    string

    Query

    meta
    optional

    If true only the document ID of the attachment blob is returned in the response body

    boolean

    "false"

    Query

    rev
    optional

    Revision identifier of the parent revision the new one should replace. (Not used when creating a new document.)

    string

    Responses
    HTTP Code Description Schema

    200

    The message body contains the attachment, in the format specified in the Content-Type header.

    string (binary)

    304

    Not Modified, the attachment wasn’t modified if ETag equals the If-None-Match header

    No Content

    400

    Bad Request - A non boolean value was supplied for the meta parameter.

    No Content

    404

    Not Found, the specified database, document or attachment was not found.

    No Content

    Example HTTP response
    Response 200
    "GET /{db}/{doc}/{attachment}?meta=true\n{\n  \"content_type\": \"text/plain\",\n  \"length\": 2,\n  \"key\": \"_sync:att2:uU0nuZNNPgilLlLX2n2r+sSE7+N6U4DukIj3rOLvzek=:sha1-Kq5sNclPz7QV2+lfQIuc6R7oRu0=\"\n}\n\n"

    Add or update a document attachment

    PUT /{db}/{doc}/{attachment}
    Description

    Use this request to add or update the supplied request content as an attachment to the specified document.

    • The maximum content size of an attachment is 20MB.

    • The attachment name must be a URL-encoded string (the file name).

    • You must also supply either the rev query parameter or the If-Match HTTP header for validation, and the Content-Type headers (to set the attachment content type).

    When uploading an attachment using an existing attachment name, the corresponding stored content of the database will be updated. Because you must supply the revision information to add an attachment to the document, this serves as validation to update the existing attachment.

    Uploading an attachment updates the corresponding document revision. Revisions are tracked for the parent document, not individual attachments.

    To remove an attachment from a document, simply update the _attachments dictionary of the document in the PUT "{db}/{id}" request.

    Sync Gateway Roles Required (CBS 7.0.2 Developer Preview):

    • Sync Gateway Application

    Parameters
    Type Name Description Schema

    Header

    Content-Type
    optional

    Attachment Content-Type

    string

    Path

    attachment
    required

    Attachment name. This value must be URL encoded. For example, if the attachment name is blob_/avatar, the path component passed to the URL should be blob_%2Favatar (tested with URLEncoder).

    string

    Path

    db
    required

    Database name

    string

    Path

    doc
    required

    Document ID

    string

    Query

    rev
    optional

    Revision identifier of the parent revision the new one should replace. (Not used when creating a new document.)

    string

    Body

    body
    optional

    The request body

    string (binary)

    Responses
    HTTP Code Description Schema

    200

    Operation completed successfully

    No Content

    409

    Conflict, the document revision wasn’t specified or it’s not the latest.

    No Content

    Logging

    Update bootstrap logging settings

    Update Logging Options

    PUT /_config
    Description

    Update bootstrap logging options without needing a restart

    Sync Gateway Roles Required (CBS 7.0.2 Developer Preview):

    • Sync Gateway Dev Ops

    Parameters
    Type Name Schema

    Body

    bootstrap logging setting
    required

    Logging_model

    Responses
    HTTP Code Description Schema

    200

    Returned updated Bootstrap logging settings

    Logging_model

    Replication

    Manage inter-Sync Gateway replication

    Create a new replication definition

    POST /{db}/_replication
    Description

    The replication endpoint is used to manage both _ad hoc and persistent replication operations.

    Using a POST request you can insert a new set of replication details.

    To Cancel a Replication You can cancel continuous replications by adding the cancel field to the JSON request object and setting the value to true. Note that the structure of the request must be identical to the original for the cancellation request to be honoured. For example, if you requested continuous replication, the cancellation request must also contain the continuous field.

    Sync Gateway Roles Required (CBS 7.0.2 Developer Preview):

    • Sync Gateway Replicator

    Parameters
    Type Name Description Schema

    Path

    db
    required

    Database name

    string

    Body

    ReplicationBody
    optional

    This replication request message body is a JSON document that comprises all the properties required to upsert a replication.

    If the replicationID matches an existing replication_id then the values of any properties provided in the body are used to update the existing replication’s property values.

    Replication_model

    Responses
    HTTP Code Description Schema

    200

    Replication successfully updated

    ReplicationResponse

    201

    Replication successfully inserted

    ReplicationResponse

    Get all replication definitions

    GET /{db}/_replication
    Description

    Returns an array object containing all replication definitions

    Sync Gateway Roles Required (CBS 7.0.2 Developer Preview):

    • Sync Gateway Replicator

    Parameters
    Type Name Description Schema

    Path

    db
    required

    Database name

    string

    Responses
    HTTP Code Description Schema

    200

    Successful response - returns an array of replication definitions in the body as JSON

    ReplicationResponseBody

    Get a replication definition

    GET /{db}/_replication/{replicationID}
    Description

    Returns requested (replicationID) replication definition

    Sync Gateway Roles Required (CBS 7.0.2 Developer Preview):

    • Sync Gateway Replicator

    Parameters
    Type Name Description Schema

    Path

    db
    required

    Database name

    string

    Path

    replicationID
    required

    The {replicationID} parameter identifies the target replication.

    string

    Responses
    HTTP Code Description Schema

    200

    Successful response - returns requested replication definition in the body as JSON

    ReplicationResponseBody

    Upsert a replication definition

    PUT /{db}/_replication/{replicationID}
    Description

    The replication endpoint is used to manage both _ad hoc and persistent replication operations.

    Using a PUT request you can update (or insert, if it doesn’t exist) a set of replication details.

    To cancel a replication You can cancel continuous replications by adding the cancel field to the JSON request object and setting the value to true.

    Note that the structure of the request must be identical to the original for the cancellation request to be honoured.

    For example, if you requested continuous replication, the cancellation request must also contain the continuous field.

    Sync Gateway Roles Required (CBS 7.0.2 Developer Preview):

    • Sync Gateway Replicator

    Parameters
    Type Name Description Schema

    Path

    db
    required

    Database name

    string

    Path

    replicationID
    required

    If supplied, the <i>replicationID</i> parameter must be a valid replication id.

    If it is not supplied for a <i>new</i> replication*, then a random UUID is generated.

    string

    Body

    ReplicationBody
    optional

    This replication request message body is a JSON document that comprises all the properties required to upsert a replication.

    If the replicationID matches an existing replication_id then the values of any properties provided in the body are used to update the existing replication’s property values.

    Replication_model

    Responses
    HTTP Code Description Schema

    200

    Replication successfully updated

    ReplicationResponse

    201

    Replication successfully inserted

    ReplicationResponse

    Security

    Cancel and delete replication

    DELETE /{db}/_replication/{replicationID}
    Description

    Deletes a specific (replicationID) replication - Removes persisted replication definition - Removes all checkpoints associated with the replication - Deletes all replication status information associated with the replication

    Sync Gateway Roles Required (CBS 7.0.2 Developer Preview):

    • Sync Gateway Replicator

    Parameters
    Type Name Description Schema

    Path

    db
    required

    Database name

    string

    Path

    replicationID
    required

    The {replicationID} parameter identifies the target replication.

    string

    Responses
    HTTP Code Description Schema

    200

    Replication successfully deleted

    No Content

    Returns replication status data for replications matching the criteria

    GET /{db}/_replicationStatus
    Description

    About

    Returns replication status data for all replications matching the criteria specified in the {querystring} parameter.

    Options

    The {queryString} parameter supports the following filter parameters - see Parameter section for more details

    • activeOnly

    • localOnly

    • includeConfig

    • includeError

    Behavior

    The selection is made from all replications across all nodes.

    By default the response includes status data for replications in any state (starting, running, stopped or error) from across all nodes.

    <h5>Example</h5>

     http://localhost:4985/{db}/_replicationStatus?activeOnly=false&localOnly=false&includeError=true

    Sync Gateway Roles Required (CBS 7.0.2 Developer Preview):

    • Sync Gateway Replicator

    Parameters
    Type Name Description Schema Default

    Path

    db
    required

    Database name

    string

    Query

    activeOnly
    optional

    When true, only active replications (state=starting, running, stopping) are returned

    boolean

    "false"

    Query

    includeConfig
    optional

    When true the replication definition is included in the response.

    boolean

    "false"

    Query

    includeError
    optional

    When false, omits replications stopped due to error (state=error)

    By default the response includes replications in error state.

    boolean

    "true"

    Query

    localOnly
    optional

    When true returns only replications run (or running) the local node since startup.

    By default the response includes replications run or running across all nodes since node start-up.

    boolean

    "false"

    Responses
    HTTP Code Description Schema

    200

    Returns information about the active replications

    ReplicationStatusResponseBody

    Returns information on specified replication

    GET /{db}/_replicationStatus/{replicationID}
    Description

    Returns the status of the requested (replicationID) replication

    Sync Gateway Roles Required (CBS 7.0.2 Developer Preview):

    • Sync Gateway Replicator

    Parameters
    Type Name Description Schema

    Path

    db
    required

    Database name

    string

    Path

    replicationID
    required

    The {replicationID} parameter identifies the target replication.

    string

    Responses
    HTTP Code Description Schema

    200

    Information about specified replication.

    ReplicationStatusResponseBody

    Modify replication status

    PUT /{db}/_replicationStatus/{replicationID}
    Description

    Use this endpoint to change the status of the specified (replicationID) replication using the value of the action parameter.

    The action parameter specifies the status to be set - valid values are

    • start - starts a stopped replication

    • stop - stops an active replication

    • reset - resets a stopped replication (resets checkpoint to zero). For bidirectional replication, both push and pull checkpoints are reset to zero.

    For example

    Sync Gateway Roles Required (CBS 7.0.2 Developer Preview):

    • Sync Gateway Replicator

    Parameters
    Type Name Description Schema Default

    Path

    db
    required

    Database name

    string

    Path

    replicationID
    required

    The {replicationID} parameter identifies the target replication.

    string

    Query

    action
    required

    The value of the {action} parameter specifies the value you want the selected replication’s status set to.

    Valid values are:

    * start : Use this action to start a stopped replication

    * stop : Use this action to stop a started replication

    * reset : Use this action to reset a stopped replication. This will set the checkpoint to zero. For bidirectional replication, both push and pull checkpoints are reset to zero.

    string

    "none"

    Responses
    HTTP Code Description Schema

    200

    The required status is successfully set

    ReplicationStatusResponseBody

    Server

    Manage server activities

    Get Server Metadata

    GET /
    Description

    Returns meta-information about the server.

    Responses
    HTTP Code Description Schema

    200

    Meta-information about the server.

    Server

    Get List of Active Tasks (v1 replications only)

    GET /_active_tasks

    operation.deprecated

    Description

    Deprecated @ 2.8

    Replaced by Inter-Sync Gateway Replication (v2)'s [_replicationStatus](#/server/get__replicationStatus) endpoint. This _active_tasks endpoint is retained only for backward compatibility.

    Use this end point to return the status of active Inter-Sync Gateway Replication (v1) replications. Only replications configured on the local node are returned.

    The response is as defined in [_replicationStatus](#/replications/getdb_replicationStatus) except that it also includes:

    • end_last_seq, which returns the maximum of (last_seq_pull, last_seq_push)

    • start_last_seq, which is not populated (as was the case prior to Sync Gateway 2.8)

    The Inter-Sync Gateway Replication (v2) equivalent is _replicationStatus?localOnly=true&activeOnly=true - see [_replicationStatus](#/replications/getdb_replicationStatus).

    Responses
    HTTP Code Description Schema

    200

    Information about active replications.

    ActiveTasks_model

    Get List of All Databases

    GET /_all_dbs
    Description

    List all databases

    Sync Gateway Roles Required (CBS 7.0.2 Developer Preview):

    • Sync Gateway Dev Ops

    Responses
    HTTP Code Description Schema

    200

    Identify all available databases

    < AllDatabases > array

    Get Server Configuration

    GET /_config
    Description

    Returns the Sync Gateway configuration of the running instance. This is a good method to check if a particular key was set correctly on the config file.

    Sync Gateway Roles Required (CBS 7.0.2 Developer Preview):

    • Sync Gateway Dev Ops

    Responses
    HTTP Code Description Schema

    200

    Sync Gateway configuration of the running instance.

    Bootstrap_model

    Update Logging Options

    PUT /_config
    Description

    Update bootstrap logging options without needing a restart

    Sync Gateway Roles Required (CBS 7.0.2 Developer Preview):

    • Sync Gateway Dev Ops

    Parameters
    Type Name Schema

    Body

    bootstrap logging setting
    required

    Logging_model

    Responses
    HTTP Code Description Schema

    200

    Returned updated Bootstrap logging settings

    Logging_model

    Get Sync Gateway Statistics

    GET /_expvar
    Description

    The `Expvar`method returns a number of runtime variables that you can view for debugging or performance monitoring purposes.

    This method can also be accessed using Sync Gateway’s Metrics REST API

    See : Sync Gateway Statistics Schema for more details on the metrics collected and reported by Sync Gateway.

    Sync Gateway Roles Required (CBS 7.0.2 Developer Preview):

    • Sync Gateway Dev Ops

    • External stats reader

    Responses
    HTTP Code Description Schema

    200

    OK - indicates success

    ExpVars

    Set Logging Tags

    POST /_logging
    Description

    Enabling logging for a tag provides additional diagnostic information for that logging area.

    The POST request only updates the tags specified in the request body.

    Sync Gateway Roles Required (CBS 7.0.2 Developer Preview):

    • Sync Gateway Dev Ops

    Parameters
    Type Name Description Schema

    Query

    level
    optional

    Deprecated - please use logLevel instead This setting determines the verbosity of the logging - level=1 - The default, regular, logging - level=2 - Enables warnings and panics logging - level=3 - Will log panics only

    integer

    Query

    logLevel
    optional

    This setting determines the verbosity of the logging.

    Available values are - none - error - warn - info - debug - trace

    Note that the setting is additive. For example, setting info will also enable both error and warn.

    string

    Body

    log_keys
    optional

    Use the body to provide a list of the log keys you want to set.

    For example - {"Changes++":true, "Cache":true, "HTTP":true, "DCP":true, "WS": true, "WSFrame": true, "Replicate": true}

    log_keys

    log_keys

    Name Description Schema

    Access
    optional

    Anytime an access() call is made in the sync function.

    boolean

    Admin
    optional

    Admin processes in Sync Gateway.

    boolean

    All
    optional

    Use the wildcard character to set all log keys For example {"":true}

    boolean

    Auth
    optional

    Authentication.

    boolean

    Bucket
    optional

    Sync Gateway interactions with the bucket (trace level only).

    boolean

    CRUD
    optional

    Updates made by Sync Gateway to documents.

    boolean

    Cache
    optional

    Interactions with Sync Gateway’s in-memory channel cache.

    boolean

    Changes
    optional

    Processing of /{db}/_changes requests.

    boolean

    DCP
    optional

    DCP-feed processing.

    boolean

    Events
    optional

    Event processing (webhooks).

    boolean

    HTTP
    optional

    All requests made to the Sync Gateway REST APIs.

    boolean

    HTTP+
    optional

    Additional information about HTTP requests (response times, status codes).

    boolean

    Import
    optional

    Introduced in Sync Gateway 1.5 to help troubleshoot the import process of a document (this is the Sync Gateway process to make a document that was added through N1QL or the Server SDKs mobile-aware). This log key can be useful to troubleshoot why a given document was not successfully imported.

    boolean

    Javascript
    optional

    All logging from Javascript. This includes - sync function, import filters, webhook filter function, and the custom ISGR conflict resolvers

    boolean

    Migrate
    optional

    Logs messages thhat show when old inline document metdata is upgraded to xattrs

    boolean

    Query
    optional

    Query is used for Sync Gateway code related to N1QL queries

    boolean

    Replicate
    optional

    Log messages related to replications between Sync Gateways (using sg-replicate). This tag cannot be used for replications initiated by Couchbase Lite.

    boolean

    SGCluster
    optional

    Log messages related to the sharded import and HA sg-replicate

    boolean

    Sync
    optional

    Activity which relates to synchronization between Couchbase Lite and Sync Gateway

    boolean

    SyncMsg
    optional

    Can be used for additional Sync logging output

    boolean

    WS
    optional

    Websocket replication log messages

    boolean

    WSFrame
    optional

    Can be used for additional WS logging output

    boolean

    gocb
    optional

    All logging emitted by the GoCB SDK

    boolean

    none
    optional

    Use "none" or "" as the key to disable all log keys. For example {"none":true}

    boolean

    Responses
    HTTP Code Description Schema

    201

    The operation was successful

    No Content

    Get Logging Tags

    GET /_logging
    Description

    Get logging tags of running instance.

    Sync Gateway Roles Required (CBS 7.0.2 Developer Preview):

    • Sync Gateway Dev Ops

    Responses
    HTTP Code Description Schema

    200

    The response is a set of key-value pairs. The key is a log tag and the value is a boolean to indicate whether this tag is enabled.

    LogTags

    Set Logging Tags

    PUT /_logging
    Description

    Enabling logging for a tag provides additional diagnostic information for that logging area.

    The PUT request replaces all existing logging tags with the ones specified in the request body.

    Sync Gateway Roles Required (CBS 7.0.2 Developer Preview):

    • Sync Gateway Dev Ops

    Parameters
    Type Name Description Schema

    Query

    level
    optional

    Deprecated - please use logLevel instead This setting determines the verbosity of the logging - level=1 - The default, regular, logging - level=2 - Enables warnings and panics logging - level=3 - Will log panics only

    integer

    Query

    logLevel
    optional

    This setting determines the verbosity of the logging.

    Available values are - none - error - warn - info - debug - trace

    Note that the setting is additive. For example, setting info will also enable both error and warn.

    string

    Body

    log_keys
    optional

    Use the body to provide a list of the log keys you want to set.

    For example - {"Changes++":true, "Cache":true, "HTTP":true, "DCP":true, "WS": true, "WSFrame": true, "Replicate": true}

    log_keys

    log_keys

    Name Description Schema

    Access
    optional

    Anytime an access() call is made in the sync function.

    boolean

    Admin
    optional

    Admin processes in Sync Gateway.

    boolean

    All
    optional

    Use the wildcard character to set all log keys For example {"":true}

    boolean

    Auth
    optional

    Authentication.

    boolean

    Bucket
    optional

    Sync Gateway interactions with the bucket (trace level only).

    boolean

    CRUD
    optional

    Updates made by Sync Gateway to documents.

    boolean

    Cache
    optional

    Interactions with Sync Gateway’s in-memory channel cache.

    boolean

    Changes
    optional

    Processing of /{db}/_changes requests.

    boolean

    DCP
    optional

    DCP-feed processing.

    boolean

    Events
    optional

    Event processing (webhooks).

    boolean

    HTTP
    optional

    All requests made to the Sync Gateway REST APIs.

    boolean

    HTTP+
    optional

    Additional information about HTTP requests (response times, status codes).

    boolean

    Import
    optional

    Introduced in Sync Gateway 1.5 to help troubleshoot the import process of a document (this is the Sync Gateway process to make a document that was added through N1QL or the Server SDKs mobile-aware). This log key can be useful to troubleshoot why a given document was not successfully imported.

    boolean

    Javascript
    optional

    All logging from Javascript. This includes - sync function, import filters, webhook filter function, and the custom ISGR conflict resolvers

    boolean

    Migrate
    optional

    Logs messages thhat show when old inline document metdata is upgraded to xattrs

    boolean

    Query
    optional

    Query is used for Sync Gateway code related to N1QL queries

    boolean

    Replicate
    optional

    Log messages related to replications between Sync Gateways (using sg-replicate). This tag cannot be used for replications initiated by Couchbase Lite.

    boolean

    SGCluster
    optional

    Log messages related to the sharded import and HA sg-replicate

    boolean

    Sync
    optional

[...]
